#include "tapnetbridge.h"
#include "sigint.h"
#include "main.h"
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <error.h>
#include <errno.h>
#include <sys/errno.h>
#include <string.h>
#include <signal.h>

#define WAIT_TIMEOUT 20

tapNetBridge::tapNetBridge(ethertap *t, network *n)
 {
  tap = t;
  net = n;
 }
 
tapNetBridge::~tapNetBridge()
 {
	tap = 0;
 	net = 0;
 }
   
void tapNetBridge::moveData()
 {
  fd_set fs;
  int r;
  timeval t;
  
  if (verbose) 
   printf("PROC: Connection now available.\n");
  
  while (!sigIntOccured)
   {
    FD_ZERO(&fs);
    FD_SET((int) *tap, &fs);
    FD_SET((int) *net, &fs);

    t.tv_sec = WAIT_TIMEOUT;
    t.tv_usec = 0;
    
    r = select(FD_SETSIZE, &fs, 0, 0, &t);
    if (sigIntOccured) break;

    if (r > 0)
     {
      if (FD_ISSET((int) *tap, &fs))
       {
        tap->read();

				if( tap->getBufLen() > 1 )
        net->write(tap->getBuf(), tap->getBufLen());
       }
  
      if (FD_ISSET((int) *net, &fs))
       {
        net->read();
          	
          	if( net->getBufLen() > 1 )
        tap->write(net->getBuf(), net->getBufLen());
       }
     }
   }

  sigIntOccured = false;
  
  if (verbose) 
   printf("PROC: Local user break.\n");
 }

void tapNetBridge::dump(char *d, int l)
 {
  int c = 0;
  printf("Dump of %i bytes:\n", l);
  
  while (l--)
   {
    printf("%02X ", (int) *  ((unsigned char*)d++)) ;
     
    if (c >= 15)
     {
      printf("\n");
      c = 0;
     }
    else
     c++;
   }

  printf("---\n");
 }
